Bug 1468490 - (CVE-2017-10979) CVE-2017-10979 freeradius: Out-of-bounds write in rad_coalesce()
CVE-2017-10979 freeradius: Out-of-bounds write in rad_coalesce()
Status: CLOSED ERRATA
Product: Security Response
Classification: Other
Component: vulnerability (Show other bugs)
unspecified
All Linux
high Severity high
: ---
: ---
Assigned To: Red Hat Product Security
impact=important,public=20170717,repo...
: Security
Depends On: 1469116 1469115 1471850
Blocks: 1468570
  Show dependency treegraph
 
Reported: 2017-07-07 04:56 EDT by Adam Mariš
Modified: 2017-08-02 05:46 EDT (History)
6 users (show)

See Also:
Fixed In Version: freeradius 2.2.10
Doc Type: If docs needed, set a value
Doc Text:
An out-of-bounds write flaw was found in the way FreeRADIUS server handled certain attributes in request packets. A remote attacker could use this flaw to crash the FreeRADIUS server or to execute arbitrary code in the context of the FreeRADIUS server process by sending a specially crafted request packet.
Story Points: ---
Clone Of:
Environment:
Last Closed: 2017-08-02 05:37:04 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Proposed patch (2.40 KB, patch)
2017-07-07 08:15 EDT, Adam Mariš
no flags Details | Diff

  None (edit)
Description Adam Mariš 2017-07-07 04:56:37 EDT
The rad_coalesce() function checks for WiMAX attributes which are too small, but it does not check for WiMAX attributes which are too large. As a result, the server can be convinced to read past the end of an attribute, and to write past the end of memory allocated via malloc().

The data being copied is taken from the attributes following the malformed WiMAX attribute, and is under the control of the attacker. While the packet has to be a "well formed" RADIUS packet, that requirement limits only the two octets which immediately follow the malformed WiMAX attribute. After that, there are up to 245 octets copied which are the complete control of the attacker.

The issue happens when the server receives any packet containing malformed WiMAX attributes, potentially leading to remote code execution.

Affected versions: 2.0.0 through 2.2.9, inclusive.
Comment 1 Adam Mariš 2017-07-07 04:56:45 EDT
Acknowledgments:

Name: the FreeRADIUS project
Upstream: Guido Vranken
Comment 2 Adam Mariš 2017-07-07 08:15 EDT
Created attachment 1295281 [details]
Proposed patch
Comment 6 Dhiru Kholia 2017-07-17 10:31:14 EDT
Created freeradius tracking bugs for this issue:

Affects: fedora-all [bug 1471850]
Comment 7 errata-xmlrpc 2017-07-17 23:42:01 EDT
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 6

Via RHSA-2017:1759 https://access.redhat.com/errata/RHSA-2017:1759
Comment 8 Dhiru Kholia 2017-08-02 05:43:07 EDT
External References:

http://freeradius.org/security/fuzzer-2017.html

Note You need to log in before you can comment on or make changes to this bug.